(*------------------------------------------------------------
TEAM02
A
138
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)

   {$APPTYPE CONSOLE}
program game;
uses
  SysUtils,
  Math;

const
	//   !
	PLAYER_NAME = 'lamer';
	MAX_SIZE = 100;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;
	
	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	me: Integer;
	size: Integer;
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
	Readln(size);
	for i := 0 to 1 do
	Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;
	
//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;
	
procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;

procedure Move();
var
	ps, ps2: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

  function getPrice(p: TPoint):integer;
	begin
    if map[p.x, p.y].isVeteran then
       result := -1;
    result := 0;
  end;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

var
	p: TPoint;
	i,j: Integer;
begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
    j:=0;
    for i:=0 to bcount do begin
      if getPrice(ps[i]) <> -1 then begin
        ps2[j] := ps[i];
        inc(j);
      end;
    end;
    i := Random(j);
    p := ps2[i];
		MoveTo(p.x, p.y);
	end;
end;

begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
		Move();
	end;
end. 
