(*------------------------------------------------------------
TEAM03
A
176
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
program Legions.Bot;
uses SysUtils, Math;
const
	//   !
	PLAYER_NAME = 'PSTU03';
	MAX_SIZE = 100;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;
	
	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	me: Integer;
	size: Integer;
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
	Readln(size);
	for i := 0 to 1 do
	Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

function CanKill(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
  else if (c.owner < 0) then  result:=false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

function CanKillNovice(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
  else if (c.owner < 0) then  result:=false
  else if (c.isVeteran) then  result:=false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;
	
//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;
	
procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;

procedure MoveToKill();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanKill(x, y) and (abs(x-y) < 4) then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

  var
	p: TPoint;
	ind: Integer;
begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

procedure MoveToKillNovice();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanKillNovice(x, y) and (abs(x-y) < 4)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

  var
	p: TPoint;
	ind: Integer;
begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

procedure MoveToKillEnemyBeforeHeKillYou();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;
  p: TPoint;
	ind: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanKill(x, y) and (abs(x-y) < 4) then
				begin
        if (me=0) and (x < 5) then begin
        ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
        end;
        if (me=1) and (x > size - 5) then begin
        ps[bcount].x := x;
        ps[bcount].y := y;
        Inc(bcount);
        end
			end;
	end;
  end;

  begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

procedure DestroyEnemyIfWeCanDoThatByNovice();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;
  p: TPoint;
	ind: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanKillNovice(x, y) and (abs(x-y) < 4) then
				begin
        if (me=0) and (x > abs(x-y) + 1) then begin
        ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
        end;
        if (me=1) and (x < abs(x-y) + 1) then begin
        ps[bcount].x := x;
        ps[bcount].y := y;
        Inc(bcount);
        end
			end;
	end;
  end;

  begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

procedure DestroyEnemyIfWeCanDoThatByVeteran();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;
  p: TPoint;
	ind: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanKill(x, y) and (abs(x-y) < 4) then
				begin
        if (me=0) and (x > size - abs(x-y) + 1) then begin
        ps[bcount].x := x;
        ps[bcount].y := y;
        Inc(bcount);
        end;
        if (me=1) and (x < abs(x-y) + 1) then begin
        ps[bcount].x := x;
        ps[bcount].y := y;
        Inc(bcount);
        end
			end;
	end;
  end;

begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

procedure Move();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y, contrsize: Integer;
	begin
		bcount := 0;
    //contrsize := size - 4;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)  then//and (abs(x-contrsize) + abs(y-contrsize) < 5)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

var
	p: TPoint;
	ind: Integer;
begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
		ind := Random(bcount);
		p := ps[ind];
		MoveTo(p.x, p.y);
	end;
end;

begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
    MoveToKillEnemyBeforeHeKillYou();
    DestroyEnemyIfWeCanDoThatByNovice();
    DestroyEnemyIfWeCanDoThatByVeteran();
    MoveToKillNovice();
    MoveToKill();
		Move();
	end;
end.
