(*------------------------------------------------------------
TEAM04
A
175
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
program legions;
uses
  SysUtils,
  Math;

const
	//   !
	PLAYER_NAME = 'PermLegion';
	MAX_SIZE = 100;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;
	
	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	me: Integer;
	size: Integer;
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;
  target : TPoint;            //    

  perimetr : integer = 3;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
	Readln(size);
	for i := 0 to 1 do
	Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;
	
//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x][y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;
	
procedure MoveTo(x, y: Integer);
var
	c: Integer;
  p:Tpoint;
begin

	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
    Writeln(ErrOutput, 'go to ', x, ' ', y);
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
    Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	end
  else
    begin
      if me=1 then p:=city[0] else p:=city[1];
        Writeln(ErrOutput, 'go to ',p.x, ' ',p.y);
        writeln(p.x,' ',p.y,' ',1);
    end;

   	Dec(legionsCount, Min(legionsCount, c));
  	Reconnect();

end;

function PerimetrProtect(): boolean;
var
i,f: integer;
begin

target.x := -1;
target.y := -1;

if me = 0 then
begin
  for i:=1 to perimetr do
    if (map[city[0].x + i,0].owner <> 0) then
      begin
        target.x := city[0].x + i;
        target.y := 0;
        result := true;
        exit;
      end;

  for i:=1 to perimetr do
    if (map[perimetr,city[0].y+i].owner <> 0) then
      begin
        target.x := perimetr;
        target.y := city[0].y + i;
        result := true;
        exit;
      end;

  for i:=1 to perimetr do
    if (map[perimetr-i,perimetr].owner <> 0) then
      begin
        target.x := perimetr - i;
        target.y := perimetr;
        result := true;
        exit;
      end;

end;

if me = 1 then
begin
  for i:=1 to perimetr do
    if (map[city[1].x - i,city[1].y].owner <> 1) then
      begin
        target.x := city[1].x - i;
        target.y := city[1].y;
        result := true;
        exit;
      end;

  for i:=1 to perimetr do
    if (map[city[1].x - perimetr,city[1].y -i].owner <> 1) then
      begin
        target.x := city[1].x - perimetr;
        target.y := city[1].y - i;
        result := true;
        exit;
      end;

  for i:=1 to perimetr do
    if (map[city[1].x-perimetr+i,city[1].y-perimetr].owner <> 1) then
      begin
        target.x := city[1].x-perimetr+i;
        target.y := city[1].y-perimetr;
        result := true;
        exit;
      end;

end;

end;

procedure BaseProtect();
var
i,f: integer;
begin

target.x := -1;
target.y := -1;

if me = 0 then
begin
 for i:= 0 to perimetr do
   for f:= 0 to perimetr do
   begin
   if map[city[0].x+i,city[0].y+f].owner = 1 then
    begin
     target.x := city[0].x+i;
     target.y := city[0].y+f;
     exit;
    end;
   end;
end;

if me = 1 then
begin
 for i:= 0 to perimetr do
   for f:= 0 to perimetr do
   begin
   if map[city[1].x-i,city[1].y-f].owner = 0 then
    begin
     target.x := city[1].x-i;
     target.y := city[1].y-f;
     exit;
    end;
   end;
end;

end;

function find_enemy(pn:TPoint):boolean;
var p,dx,dy,s,e,i,nme:integer;
begin
  if me=1 then
    begin
      dy:=-1;
      dx:=-1;
      nme:=0;
    end
  else
    begin
      dy:=1;
      dx:=1;
      nme:=1;
    end;
  if map[city[me].x,city[me].y+dy*perimetr].owner=-1 then p:=perimetr-1 else p:=perimetr;
  if (map[city[me].x,city[me].y+dy*p].owner=me)and(map[city[me].x,city[me].y+dy*p].isConnected)then
    begin
      find_enemy:=false;
      exit;
    end
  else
    begin
      s:=city[me].x;
      e:=city[me].x+p*dx;
      if s>e then
        begin
          e:=s+e;
          s:=e-s;
          e:=e-s;
        end;
      for i:=s to e do
        if map[city[me].x+i*dx,city[me].y+dy*p].owner=nme then
          begin
            pn.x:= city[me].x+i*dx;
            pn.y:= city[me].y+dy*p;
            find_enemy:=true;
            exit;
          end;
      s:=city[me].y+p*dy;
      e:=city[me].y;
      if s>e then
        begin
          e:=s+e;
          s:=e-s;
          e:=e-s;
        end;
      for i:=s to e do
        if map[city[me].x+p*dx,city[me].y+i*dy].owner=nme then
          begin
            pn.x:= city[me].x+p*dx;
            pn.y:= city[me].y+i*dy;
            find_enemy:=true;
            exit;
          end;
      s:=city[me].x+p*dx;
      e:=city[me].x;
      if s>e then
        begin
          e:=s+e;
          s:=e-s;
          e:=e-s;
        end;
      for i:=s to e do
        if map[city[me].x+i*dx,city[me].y].owner=nme then
          begin
            pn.x:= city[me].x+i*dx;
            pn.y:= city[me].y;
            find_enemy:=true;
            exit;
          end;
    end;
  find_enemy:=false;
end;

procedure Move({step:integer; var points:integer});
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;
  b : boolean;
  n : integer;
	
	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;
		
var 
	p: TPoint;
	ind: Integer;
  i,dx,dy,nme:integer;
begin
	Writeln(ErrOutput);
  if me=1 then
    begin
      dy:=-1;
      dx:=-1;
      nme:=0;
    end
  else
    begin
      dy:=1;
      dx:=1;
      nme:=1;
    end;
	while legionsCount > 0 do
	begin
    if find_enemy(p) then
      begin
        if(p.x=p.y)then
        if(map[p.x,p.y+dy].owner=nme)then
          begin
            moveto(p.x-dx,p.y+dy);
            moveto(p.x,p.y+dy);
          end
        else
          begin
            moveto(p.x+dx,p.y-dy);
            moveto(p.x+dx,p.y);
          end;
        if(abs(city[me].x-p.x)>abs(city[me].y-p.y)) then
          begin
            moveto(p.x+dx,p.y+dy);
            moveto(p.x+dx,p.y);
          end;
        if(abs(city[me].x-p.x)<abs(city[me].y-p.y))then
          begin
            moveto(p.x+dx,p.y+dy);
            moveto(p.x,p.y+dy);
          end;
      end;
    b := false;
  ///
    b := PerimetrProtect();
    if (target.x <> -1) then
    begin
     MoveTo(target.x, target.y);
    end;
  ///

    if not b then
    begin
      inc(perimetr,1);
      BaseProtect();
      if (target.x <> -1) then
      begin
       MoveTo(target.x, target.y);
      end;
    end;
       

    if (target.x = -1) then
    begin
		FindAccessiblePoints();
   	if bcount = 0 then exit;
    ind := Random(bcount);
    p := ps[ind];
    MoveTo(p.x, p.y);
    end;

	end;
end;

begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
		Move();
	end;
end.
