/*------------------------------------------------------------
TEAM06
A
171
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <ctime>
#include <queue>

using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}
		
	void Move()
	{
		srand(time(0));
		while (legionsCount)
		{
			vector<Point> *ps = GetAccessiblePoints();
			if (!ps->empty())
			{
				//!!!!!!!!!!!!!!!!!!!!!!!
				/*
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);*/
			    if (!p1_a(ps))
					if (!p1_b(ps))
					{
                      	//for (int j = )				
						if (!p3(ps))
								p4(ps);
					}

			}
			delete ps;
		}
	}

protected:
	bool p1_a(vector<Point>* ps)
	{
	  for (int i = 0; i < ps->size(); ++i)
	  {
	    Point p = (*ps)[i];
		if (p.x == city[enemy].x && p.y == city[enemy].y)
		{
			MoveTo(p.x, p.y);
			return true;
		}
	  }
	  return false;
	}


	bool can(int x, int y)
	{
	  return x >= 0 && x < size && y >= 0 && y < size;
	}

	bool p1_b(vector<Point>* ps)
	{
		queue<Point> q;
		int table[50][50];
        int sum[50][50];
		int nnew[50][50];
		
        memset(sum, 0, sizeof(sum));

		for (int i = 0; i < size; ++i)
			for (int j = 0; j < size; ++j)
			{
				if (map[i][j].owner == me)
				  table[i][j] = 0;
    			if(map[i][j].owner == -1)
					table[i][j] = 1;
				if (map[i][j].owner == enemy)
				{
					if (map[i][j].isVeteran)
						table[i][j] = 3;
					else
						table[i][j] = 2;
				}
			}
        q.push(city[me]);
		
		const int dx[] = {-1, 0, 1, 0}, dy[] = {0, 1, 0, -1};

		memset(nnew, 0, sizeof(nnew));

		Point pred[50][50];

	    while (!q.empty())
		{
		  Point p = q.front();
		  q.pop();

		  int x = p.x, y = p.y;
		  nnew[x][y] = 2;

		  for (int k = 0; k < 4; ++k)
		    if (can(x + dx[k], y + dy[k]))
			{
			  int nx = x + dx[k], ny = y + dy[k];
			  if (!nnew[nx][ny])
			  {
			    sum[nx][ny] = sum[x][y] + table[nx][ny];
				nnew[nx][ny] = 1;
				q.push(Point(nx, ny));
				pred[nx][ny] = Point(x, y);
			  }
			  else
				  if (nnew[nx][ny] == 1 && sum[nx][ny] > sum[x][y] + table[nx][ny])
				  {
				    sum[nx][ny] = sum[x][y] + table[nx][ny];
					pred[nx][ny] = Point(x, y);
				  }
				  else
					  if (nnew[nx][ny]==2 && sum[nx][ny] > sum[x][y] + table[nx][ny])
					  {
						    sum[nx][ny] = sum[x][y] + table[nx][ny];
							pred[nx][ny] = Point(x, y);
							q.push(Point(nx, ny));
							nnew[nx][ny] = 1;
					  }
			}
		}

		if (sum[city[enemy].x][city[enemy].y] <= legionsCount)
		{
		  vector<Point> path;
          int x = city[enemy].x, y = city[enemy].y;

		  while (sum[x][y])
		  {
	  		  path.push_back(Point(x, y));
              int _x = pred[x][y].x;
			  y = pred[x][y].y;
              x = _x;
		  }
          
		  for (int i = path.size() - 1; i >= 0; --i)
		  {
			  if(!MoveTo(path[i].x, path[i].y))
			  {
				  return false;			
				  break;
			  }
		  }
		  return true;
		}

		return false;
	}




    bool p3(vector<Point>* ps)
	{
	  bool ok = false;
	  Point *p_empty = 0, *p_new = 0, *p_vet = 0;

	  for (int i = 0; i < ps->size(); ++i)
	  {
	    Point p = (*ps)[i];
        if (!p_empty)
		  if (map[p.x][p.y].owner == -1)
			  p_empty = new Point(p.x, p.y);
		
		if (!p_new)
			if (map[p.x][p.y].owner == enemy && !map[p.x][p.y].isVeteran)
			  p_new = new Point(p.x, p.y);;

		if (!p_vet)
			if (map[p.x][p.y].owner == enemy && map[p.x][p.y].isVeteran)
			  p_vet = new Point(p.x, p.y);;
	  }

	  if (p_empty && p_new)
		{
		  MoveTo(p_new->x, p_new->y);
		  ok =  true;
		}
		else
			if (p_new && p_vet)
			{
			  MoveTo(p_vet->x, p_vet->y);
			  ok = true;
			}
			else
				if (p_new)
				{
				  MoveTo(p_new->x, p_new->y);
				  ok = true;
				}
	
		delete p_new;
		delete p_empty;
		delete p_vet;

		return ok;
	}

	bool p4(vector<Point>* ps)
	{
		Point p = (*ps)[rand() % ps->size()];
		MoveTo(p.x, p.y);
		return true;
	}
/*
	bool p2(vector<Point>* ps)
	{
      for (int i = 0; i < ps->size(); ++i)
		{
			Point p = (*ps)[i];
			Cell c = map[p.x][p.y];
			if ((c.owner == enemy && !c.isVeteran) && aroundMyVeteran(p))
			{
              MoveTo(p.x, p.y);
   			  return true;
    		}
		}

		return false;
	}
	*/
	bool isMyVeteran(int x, int y) // enemy legion on x,y
	{
		return x >= 0 && x < size && y >= 0 && y < size && map[x][y].isVeteran && map[x][y].owner == me;
	}

/*	bool aroundMyLegion(const Point& p)
	{
	  int x = p.x, y = p.y;
      bool ok = isLegion(x - 1, y) || isLegion(x, y + 1) || isLegion(x + 1, y) || isLegion(x, y - 1);
	  
	}
	*/
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	bool MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		else
			return false;
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
		return true;
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "SUrSU #2 Bot";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
	
	return 0;
}
