/*------------------------------------------------------------
TEAM15
A
179
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <iostream>
using namespace std;

const int MAXBUFLEN = 1000;
const int dangerDistance = 7;
const int maxn = 20;

struct point {
	int x, y;
	point(int x = 0, int y = 0) {
		this->x = x;
		this->y = y;
	}
};

struct Cell {
   int x, y;
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot {
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	point city [2];
   int minDist[maxn][maxn];
   point en[maxn][maxn];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions) {
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot() {
		if (map) {
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName() {
		return BOT_NAME;
	}
	bool InputData() {
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++) {
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++) {
			for (x = 0; x < size; x++) {
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
            map[x][y].x = x;
            map[x][y].y = y;
				if (strncmp(buffer,".",1) != 0) {
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}

   int sign(int x) {
      if (x >= 0) {
         return 1;
      } else {
         return -1;
      }
   }

   void attack(int i, int j) {
      int ei = en[i][j].x;
      int ej = en[i][j].y;
      int di = sign(i - ei);
      int dj = sign(j - ej);
      //while (i != ) {
      //}
   }

	void Move() {
		if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");
/*
		while (legionsCount)
		{
			vector<point> *ps = GetAccessiblePoints();
			if (ps->size())
			{
				point p = (*ps)[rand() % ps->size()];
				moveTo(p.x, p.y);
			}
			delete ps;
		}*/
      
      //Log("!!!\n");
      
      for (int i = city[me].x - 2; i <= city[me].x + 2; ++i) {
         for (int j = city[me].y - 2; j <= city[me].y + 2; ++j) {
            if (isValidPoint(i, j) && map[i][j].owner < 0 && canMoveTo(i, j)) {
               //fprintf(stderr,"%d %d\n", i, j);
               
               if (i == 0 && j == 1) {
                  moveTo(i, j);
               } else {
                  moveTo(i, j);
               }
            }
         }
      }
      Log("???\n");
      
      

      
      while (legionsCount > 0) {
         int movesBefore = legionsCount;
         fillSafe();

         for (int i = 0; i < size; ++i) {
            for (int j = 0; j < size; ++j) {
               if (minDist[i][j] < 2 && map[i][j].owner == me) {
                  for (int i1 = i - 1; i1 < i + 1; ++i1) {
                     for (int j1 = j - 1; j1 < j + 1; ++j1) {
                        if (isValidPoint(i1, j1) && abs(i1 - i) + abs(j1 - j) == 1 && canMoveTo(i1, j1) && map[i1][j1].owner == enemy) {
                           moveTo(i1, j1);
                        }
                     }
                  }
               }
            }
         }
         if (movesBefore == legionsCount) {
            break;
         }
      }
      fillSafe();
      Log("!!!\n");
      

      while (legionsCount > 0) {
         fillSafe();
         point best;
         int md = 1000000;
         for (int i = 0; i < size; ++i) {
            for (int j = 0; j < size; ++j) {
               if (map[i][j].owner != me || !map[i][j].isConnected) {
                  continue;
               }
               for (int i1 = i - 1; i1 <= i + 1; ++i1) {
                  for (int j1 = j - 1; j1 <= j + 1; ++j1) {
                     if (isValidPoint(i1, j1) && abs(i1 - i) + abs(j1 - j) == 1 && map[i1][j1].owner != me) {
                        if (minDist[i1][j1] < md && minDist[i1][j1] > 2) {
                           best = point(i1, j1);
                           md = minDist[i1][j1];
                        }
                     }
                  }
               }
            }
         }
         if (md == 1000000) {
            break;
         }
         moveTo(best.x, best.y);
         fprintf(stderr,"%d %d  %d\n", best.x, best.y, md);
      }
	}

protected:
   bool isValidPoint(int i, int j) {
      return i >= 0 && i < size && j >= 0 && j < size;
   }

   void fillSafe() {
      memset(minDist, 127, sizeof(minDist));
      for (int i = 0; i < size; ++i) {
         for (int j = 0; j < size; ++j) {
            if (map[i][j].owner == enemy && map[i][j].isConnected) {
               for (int i1 = 0; i1 < size; ++i1) {
                  for (int j1 = 0; j1 < size; ++j1) {
                     if (abs(i - i1) + abs(j - j1) < minDist[i1][j1]) {
                        minDist[i1][j1] = abs(i - i1) + abs(j - j1);
                        en[i1][j1] = point(i, j);
                     }
                  }
               }
            }
         }
      }
   }




	vector<point>* GetAccessiblePoints() {
		vector<point> *ps = new vector<point>();
		ps->assign(0, point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (canMoveTo(x, y))
					ps->push_back(point(x,y));
		return ps;
	}
	bool canMoveTo(int x, int y) {
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool MyConnected(int x, int y) {
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message) {
		fprintf(stderr,"%s\n", message);
	}

	void moveTo(int x, int y) {
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count) {
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
      } else {
         return;
      }
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
	}

	void Reconnect() {
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me) {
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "Vologda";
int SampleBot::maxLegions = 5;

int  main() {
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
