(*------------------------------------------------------------
TEAM26
A
169
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
program dbot;
uses
  SysUtils,
  Math;

const
	PLAYER_NAME = ' 2';
	MAX_SIZE = 16;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;
	
	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	me,you: Integer;

	size: Integer;
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
  if me=1 then
    you:=0
  else
    you:=1;
	Readln(size);
	for i := 0 to 1 do
	Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
        read(c2);
			end

			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;
	
//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;
	
procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;

procedure Move();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;
	
	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;
		
var
  i,flag,lenx,leny: integer;
	p: TPoint;
	ind: Integer;
begin
  i:=0;
  flag:=1;
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
    //-------------------------
    while (flag=1)and (i<bcount) do
    begin 
    lenx:=abs(ps[i].x - city[me].x);
    leny:=abs(ps[i].y - city[me].y);

       if(map[ps[i].x][ps[i].y].owner=you) and ((lenx<3) or (leny<3)) then
         begin
            flag:=0;
            p := ps[i];
            MoveTo(p.x, p.y);
         end;inc(i);
     end;

     i:=0;
     while ((flag=1)and (i<bcount) and(legionsCount>1))do
     begin


       if (map[ps[i].x][ps[i].y].owner=you) and (map[ps[i].x][ps[i].y].isVeteran=true) and (legionsCount>2) then
       begin
         p := ps[i]; MoveTo(p.x, p.y);inc(i);
       end;

     if (map[ps[i].x][ps[i].y].owner=you) and (map[ps[i].x][ps[i].y].isVeteran=false) and (legionsCount>1) then
       begin
         p := ps[i]; MoveTo(p.x, p.y);
       end;
          inc(i);
       if(legionsCount<2) then flag:=0;
     end;

    if((flag=0)and(legionsCount<2)) then
     begin
    ind := Random(bcount);
   	p := ps[ind];
		MoveTo(p.x, p.y);
    end;

    if flag=1 then
    begin
    ind := Random(bcount);
   	p := ps[ind];
		MoveTo(p.x, p.y);
    end;
	end;
end;

begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
		Move();
	end;
end.

