/*------------------------------------------------------------
TEAM28
A
179
Target: LegionCs; Platform: Win32; Comment: C# (.Net 2.0) (Legionaries)
------------------------------------------------------------*/
using System;
using System.Collections;
using System.IO;

public class SampleBot
{
	// Придумайте своё название!
	private static readonly String BOT_NAME = "sample";
		
	private class Point
	{
		public Point(int x, int y)
		{
			this.x = x;
			this.y = y;
		}
		
		public int x, y;
	}

	private class Cell
	{
		public int owner = -1;
		public bool isVeteran = false;
		public bool isConnected = false;
	}

	private int me;

	private int enemy;

	private int size;

	private int legionsCount = 5;

	private Point[] city = new Point[2];

	private Cell[,] map;

	private Random rand = new Random();

	private static void Main()
	{
		try
		{
			SampleBot r = new SampleBot();
			if (r.InputData(Console.In)) r.Move();
			else Console.WriteLine(BOT_NAME);
		}
		catch(Exception e)
		{
			Console.Error.Write(e.ToString());
		}
	}

	private bool InputData(TextReader r)
	{
		string firstLine = r.ReadLine();
		if (firstLine == null || firstLine.Trim() == "") return false;
		me = int.Parse(firstLine.Trim());
		enemy = 1 - me;
		size = int.Parse(r.ReadLine().Trim());
		map = new Cell[size,size];
		for (int i = 0; i < 2; i++)
		{
			string[] coords = r.ReadLine().Split(' ');
			city[i] = new Point(int.Parse(coords[0]), int.Parse(coords[1]));
		}
		for (int y = 0; y < size; y++)
		{
			string[] line = r.ReadLine().Split('\t');
			for (int x = 0; x < size; x++)
			{
				string c = line[x];
				map[x, y] = new Cell();
				char c1 = c[0];
				if (c1 != '.')
				{
					map[x, y].owner = c[1] - '0';
					map[x, y].isVeteran = c1 == 'v' || c1 == 'V';
					map[x, y].isConnected = c1 == 'N' || c1 == 'V';
				}
			}
		}
		return true;
	}
	
	private void Move()
	{
		if (rand.Next(100) > 98) Log("Show must go on!");
		else if (rand.Next(100) > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand.Next(100) > 95) Log("Hmm...");
		else if (rand.Next(100) > 95) Log("Aha! He-he-he :-)");
		while (legionsCount > 0)
		{
			Point[] ps = GetAccessiblePoints();
			if (ps.Length == 0) return;
			Point p = ps[rand.Next(ps.Length)];
			MoveTo(p.x, p.y);
		}
	}

	private Point[] GetAccessiblePoints()
	{
		ArrayList ps = new ArrayList();
		for (int y = 0; y < size; y++)
			for (int x = 0; x < size; x++)
				if (CanMoveTo(x, y)) ps.Add(new Point(x, y));
		return (Point[]) ps.ToArray(typeof (Point));
	}

	private bool CanMoveTo(int x, int y)
	{
		Cell c = map[x, y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	private bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) return false;
		return map[x, y].owner == me && map[x, y].isConnected;
	}

	private static void Log(string message, params object[] args)
	{
		Console.Error.Write(String.Format(message, args));
	}

	private void MoveTo(int x, int y)
	{
		int count;
		if (map[x, y].owner != enemy) count = 1;
		else if (map[x, y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x, y].owner = me;
			map[x, y].isVeteran = count > 1;
			map[x, y].isConnected = true;
		}
		Console.WriteLine(x + " " + y + " " + Math.Min(count, legionsCount));
		legionsCount -= count;
		Reconnect();
	}

	private void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x, y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	private void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x,y].owner != me) return;
		if (map[x,y].isConnected) return;
		map[x,y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
}
