/*------------------------------------------------------------
TEAM31
A
167
Target: LegionCs; Platform: Win32; Comment: C# (.Net 2.0) (Legionaries)
------------------------------------------------------------*/
using System;
using System.Collections;
using System.IO;

public class SampleBot
{
	// Придумайте своё название!
	private static readonly String BOT_NAME = "OSU - TEAM 2";
		
	private class Point
	{
		public Point(int x, int y)
		{
			this.x = x;
			this.y = y;
		}
		
		public int x, y;
	}

	private class Cell
	{
		public int owner = -1;
		public bool isVeteran = false;
		public bool isConnected = false;
	}

	private int me;

	private int enemy;

	private int size;

	private int legionsCount = 5;

	private Point[] city = new Point[2];

	private Cell[,] map;

	private Random rand = new Random();

	private static void Main()
	{
		try
		{
			SampleBot r = new SampleBot();
			if (r.InputData(Console.In)) r.Move();
			else Console.WriteLine(BOT_NAME);
		}
		catch(Exception e)
		{
			Console.Error.Write(e.ToString());
		}
	}

	private bool InputData(TextReader r)
	{
		string firstLine = r.ReadLine();
		if (firstLine == null || firstLine.Trim() == "") return false;
		me = int.Parse(firstLine.Trim());
		enemy = 1 - me;
		size = int.Parse(r.ReadLine().Trim());
		map = new Cell[size,size];
		for (int i = 0; i < 2; i++)
		{
			string[] coords = r.ReadLine().Split(' ');
			city[i] = new Point(int.Parse(coords[0]), int.Parse(coords[1]));
		}
		for (int y = 0; y < size; y++)
		{
			string[] line = r.ReadLine().Split('\t');
			for (int x = 0; x < size; x++)
			{
				string c = line[x];
				map[x, y] = new Cell();
				char c1 = c[0];
				if (c1 != '.')
				{
					map[x, y].owner = c[1] - '0';
					map[x, y].isVeteran = c1 == 'v' || c1 == 'V';
					map[x, y].isConnected = c1 == 'N' || c1 == 'V';
				}
			}
		}
		return true;
	}
	private void Check_Oboron()
	{
		
		if (me == 0)
		{
			MoveTo(0,1);
			MoveTo(1,0);
		}
		else
		{
			MoveTo(size-1,size-2);
			MoveTo(size-2,size-1);

		}
		/*if (me == 0)
		{
			if (map[city[me].x,city[me].y+1].owner != me)
			{
				MoveTo(city[me].x,city[me].y+1);
			}
			if (map[city[me].x+1,city[me].y].owner != me)
			{
				MoveTo(city[me].x+1,city[me].y);
			}
			if (map[city[me].x+1,city[me].y+1].owner != me)
			{
				MoveTo(city[me].x+1,city[me].y+1);
			}
			if (map[city[me].x,city[me].y+2].owner != me)
			{
				MoveTo(city[me].x,city[me].y+2);
			}
			if (map[city[me].x+2,city[me].y].owner != me)
			{
				MoveTo(city[me].x+2,city[me].y);
			}

		}
		else
		{
			if (map[city[me].x,city[me].y-1].owner != me)
			{
				MoveTo(city[me].x,city[me].y-1);
			}
			if (map[city[me].x-1,city[me].y].owner != me)
			{
				MoveTo(city[me].x-1,city[me].y);
			}
			if (map[city[me].x-1,city[me].y-1].owner != me)
			{
				MoveTo(city[me].x-1,city[me].y-1);
			}
			if (map[city[me].x,city[me].y-2].owner != me)
			{
				MoveTo(city[me].x,city[me].y-2);
			}
			if (map[city[me].x-2,city[me].y].owner != me)
			{
				MoveTo(city[me].x-2,city[me].y);
			}
		}
/**/
	}


	private Point[] EnemyCells()
	{
		ArrayList ps = new ArrayList();
		for (int y = 0; y < size; y++)
			for (int x = 0; x < size; x++)
				if (CanMoveTo(x, y) && map[x,y].owner == enemy) 
					ps.Add(new Point(x, y));
		return (Point[]) ps.ToArray(typeof (Point));
	}


	private void Check_Oboron2()
	{
		int i, x, y;
		if (me == 0)
		{
			for (x = 0,y = 3; x!= 3 && y!= 0; x++,y--)
				if (map[x,y].owner == enemy)
					MoveTo(x,y);
		}
		else
		{
			for (x = size-1,y = size-4; x!= size-4 && y!= size-1; x--,y++)
				if (map[x,y].owner == enemy)
					MoveTo(x,y);
		}
		/*if (me == 0)
		{
			for (x = 0,y = 4; x!= 4 && y!= 0; x++,y--)
				if (map[x,y].owner == enemy)
					MoveTo(x,y);
		}	
		else
		{
			for (x = size-1,y = size-5; x!= size-5 && y!= size-1; x--,y++)
				if (map[x,y].owner == enemy)
					MoveTo(x,y);
		}/**/
	}

	private void Move_Diag()
	{
		int m = 0;
		int inc;
		
		if (me == 0)
		{
			m = 0;
			inc = 1;
		}
		else
		{
			m = size-1;
			inc = -1;
		}
		while (map[m,m].owner == me)
			m = m + inc;
		m = m - inc;
		if (map[m+inc,m].owner == me || map[m,m+inc].owner == me)
		{
			if (CanMoveTo(m+inc,m+inc))
				MoveTo(m+inc,m+inc);
			else
				RandMove();
		}
		else
		{
			if (rand.Next(100) > 50)
			{
				if (CanMoveTo(m,m+inc))
					MoveTo(m,m+inc);
				else
				{ 
					if (CanMoveTo(m+inc,m))
						MoveTo(m+inc,m);
					else
						RandMove();
				}
			}
			else
			{
				if (CanMoveTo(m+inc,m))
					MoveTo(m+inc,m);
				else
				{
					if (CanMoveTo(m,m+inc))
						MoveTo(m,m+inc);
					else
						 RandMove();
				}
			}

		}

	}
	private void RandMove()
	{
		Point [] ps = GetAccessiblePoints();
		if (ps.Length == 0)
			return;
		int i = rand.Next(ps.Length);
		MoveTo(ps[i].x,ps[i].y);
		/**/
		/*int x, y;
		for (int j = 3; j < size/3; j++)
		if (me == 0)
		{
			for (x = 0,y = j; x!= j && y!= 0; x++,y--)
				if (map[x,y].owner != me)
					MoveTo(x,y);
		}
		else
		{
			for (x = size-1,y = size-j-1; x!= size-j-1 && y!= size-1; x--,y++)
				if (map[x,y].owner != me)
					MoveTo(x,y);
		}/**/

	}

	private void Move()
	{
		//Check_Oboron2();
		//Check_Oboron();
		Point[] enems = EnemyCells();
		int max = 0, mindex = 0;
		if (enems.Length == 0)
			while (legionsCount > 0)
				Move_Diag();
		else
			while (legionsCount > 0 && enems.Length > 0)
			{
				if (me == 0)
					max = -1;
				else
					max = size+size+1;
				for (int i = 0; i < enems.Length; i++)
					if ((me == 0 && max < (enems[i].x + enems[i].y /*- Convert.ToInt16(map[enems[i].x,enems[i].y].isVeteran)/**/)) ||(me == 1 && max > (enems[i].x + enems[i].y/*+ Convert.ToInt16(map[enems[i].x,enems[i].y].isVeteran)/**/)))
					{
						max = enems[i].x + enems[i].y;
						mindex = i;
					}

				Point p = enems[mindex];
				MoveTo(p.x, p.y);
				enems = EnemyCells();

			}
		while (legionsCount > 0)
			Move_Diag();
	}

	private Point[] GetAccessiblePoints()
	{
		ArrayList ps = new ArrayList();
		for (int y = 0; y < size; y++)
			for (int x = 0; x < size; x++)
				if (CanMoveTo(x, y)) ps.Add(new Point(x, y));
		return (Point[]) ps.ToArray(typeof (Point));
	}

	private bool CanMoveTo(int x, int y)
	{
		Cell c = map[x, y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	private bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) return false;
		return map[x, y].owner == me && map[x, y].isConnected;
	}

	private static void Log(string message, params object[] args)
	{
		Console.Error.Write(String.Format(message, args));
	}

	private int MoveTo(int x, int y)
	{
		int count;
		if (map[x,y].owner == me) return 0;
		if (map[x, y].owner != enemy) count = 1;
		else if (map[x, y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x, y].owner = me;
			map[x, y].isVeteran = count > 1;
			map[x, y].isConnected = true;
		}else
			return 0;
		Console.WriteLine(x + " " + y + " " + Math.Min(count, legionsCount));
		legionsCount -= count;
		Reconnect();
		return 1;
	}

	private void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x, y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	private void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x,y].owner != me) return;
		if (map[x,y].isConnected) return;
		map[x,y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
}
