(*------------------------------------------------------------
TEAM40
A
175
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
program our_2;
uses SysUtils, Math;
const
	//   !
	PLAYER_NAME = 'sample';
	MAX_SIZE = 100;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;

	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	i, j, me: Integer;
	size: Integer;
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;
  ar: Array[0..16, 0..16] of Integer;
  maso: Boolean;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
	Readln(size);
	for i := 0 to 1 do
	  Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then
    result := false
	else
    result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then
    result := false
	else
    if (c.owner >= 0) and (legionsCount < 2) then
      result := false
	  else
      if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then
        result := false
	    else
        result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then
    exit;
	if map[x,y].owner <> owner then
    exit;
	if map[x,y].isConnected then
    exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;

//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;

procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;

procedure FillArray;
var
  i, j: Integer;
  mas: Array[0..max_size, 0..MAX_SIZE] of Integer;
begin
  Fillchar(ar, sizeof(ar), 0);
  for i := 0 to 2 do
    for j := 0 to 2 do
      ar[i, j] := 1;

  for i := 1 to 5 do
    for j := 1 to 5 do
      if ar[i, j] = 0 then
        ar[i, j] := 2;
  ar[2, 4] := 2;
  ar[3, 2] := 2;
  ar[4, 2] := 2;
  ar[4, 3] := 2;

  for i := 1 to 8 do
    ar[8, i] := 3;
  for i := 1 to 8 do
    ar[i, 8] := 3;
  ar[1, 6] := 3;
  ar[1, 7] := 3;
  ar[6, 1] := 3;
  ar[7, 1] := 3;
  ar[6, 6] := 3;
  ar[7, 7] := 3;
  ar[6, 5] := 3;
  ar[7, 6] := 3;

  for i := 1 to 11 do
    ar[11, i] := 4;
  for i := 1 to 11 do
    ar[i, 11] := 4;
  ar[1, 9] := 4;
  ar[1, 10] := 4;
  ar[9, 1] := 4;
  ar[10, 1] := 4;
  ar[9, 9] := 4;
  ar[10, 10] := 4;
  ar[8, 9] := 4;
  ar[9, 10] := 4;
  if me = 1 then
  begin
    fillchar(mas, sizeof(mas), 0);
    for i := 0 to size-1 do
      for j := 0 to size-1 do
        mas[size-1-i, size-1-j] := ar[i, j];
    fillchar(ar, sizeof(ar), 0);
    for i := 0 to size-1 do
      for j := 0 to size-1 do
        ar[i, j] := mas[i, j];
  end;
end;

function Delta: Integer;
var
  i, j, min, krayT, krayM, k: Integer;
begin
  min := 0;
  for i := 0 to size - 1 do
  begin
    for j := 0 to size - 1 do
    begin
      if map[i, j].owner = me then
      begin
        for k := 0 to size - 1 do
        begin
          if (not map[i, k].owner = me) and (map[i, k].owner <> -1) then
          begin
            krayT := k;
            krayM := j;
            if min > abs(krayT - krayM) then
              min := abs(krayT - krayM);
          end;
          if (not map[k, j].owner = me) and (map[k, j].owner <> -1) then
          begin
            krayT := k;
            krayM := i;
            if min > abs(krayT - krayM) then
              min := abs(krayT - krayM);
          end;
        end;
      end;
    end;
  end;
  result := min;
end;

procedure FillPole;
var
  value, minx, miny, i, j: Integer;
begin
  value := 999;
  minx := 999;
  miny := 999;
  for i := 0 to size - 1 do
    for j := 0 to size - 1 do
    begin
      if (map[i, j].owner = -1) and (ar[i, j] <> 0) and (canmoveTo(i, j)) then
       if value > ar[i, j] then
        begin
          value := ar[i, j];
          minx := i;
          miny := j;
        end;
    end;
  if (legionscount > 0) then
  begin
    MoveTo(minx, miny);
    ar[minx, miny] := 0;
  end;
end;

procedure Defend;
var
  i, j: Integer;
begin
  for i := 0 to size - 1 do
    for j := 0 to size - 1 do
    begin
      if (CanMoveTo(i, j)) and (legionscount > 0) then
      begin
        MoveTo(i, j);
      end;
    end;
end;

procedure Attack;
var
  cnt, i, j: Integer;
begin
  cnt := 0;
  for i := 0 to size - 1 do
    for j := 0 to size - 1 do
    begin
      if (map[i, j].owner = me) then
      begin
        if (map[i, j - 1].owner <> me) and (map[i, j - 1].owner <> -1) and (legionscount > 0) and (j > 0) and (canmoveto(i, j -1)) then
          inc(cnt);
        if (map[i, j + 1].owner <> me) and (map[i, j + 1].owner <> -1) and (legionscount > 0) and (j < size - 1) and (canmoveto(i, j +1)) then
          inc(cnt);
        if (map[i - 1, j].owner <> me) and (map[i - 1, j].owner <> -1) and (legionscount > 0) and (i > 0) and (canmoveto(i - 1, j))  then
          inc(cnt);
        if (map[i + 1, j].owner <> me) and (map[i + 1, j].owner <> -1) and (legionscount > 0) and (i < size - 1) and (canmoveto(i + 1, j)) then
          inc(cnt);
      end;
      if cnt >= 1 then
      begin
        if (map[i, j - 1].owner <> me) and (map[i, j - 1].owner <> -1) and (legionscount > 0)  and (j > 0) and (canmoveto(i, j -1)) then
          MoveTo(i, j - 1);
        if (map[i, j + 1].owner <> me) and (map[i, j + 1].owner <> -1) and (legionscount > 0) and (j < size - 1) and (canmoveto(i, j +1))then
          MoveTo(i, j + 1);
        if (map[i - 1, j].owner <> me) and (map[i - 1, j].owner <> -1) and (legionscount > 0) and (i > 0) and (canmoveto(i - 1, j)) then
          MoveTo(i - 1, j);
        if (map[i + 1, j].owner <> me) and (map[i + 1, j].owner <> -1) and (legionscount > 0) and (i < size - 1) and (canmoveto(i + 1, j)) then
          MoveTo(i + 1, j);
      end;
    end;
  while legionscount > 0 do
    Defend;
end;

procedure Choose;
var
  delt: Integer;
begin

  if not maso then
  begin
    delt := Delta;
    if delt > 2 then
    begin
      while legionscount > 0 do
        FillPole;
    end
    else
      if delt = 2 then
        while legionscount > 0 do
          Defend
      else
      begin
        maso := true;
        while legionscount > 0 do
          Attack;
      end;
  end
  else
    while legionscount > 0 do
      Attack;
end;

begin
	Randomize();
  maso := false;
  FillArray;
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData;

    {for i := 0 to 11 do
    begin
      for j := 0 to 11 do
        write(ar[i, j], ' ');
      writeln;
    end;
    readln;}
		//Move();
    Choose;
    //Attack;
    //FillPole;
	end;
end.
