/*------------------------------------------------------------
TEAM45
A
176
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	int angry;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		angry = size;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}
		
	void Move2()
	{
		//int len=abs(x-city[me].x)+abs(y-city[me].y);
		if (map[city[me].x][city[me].y].owner!=me)
			MoveTo(city[me].x,city[me].y);
		int minX, minY, min=2*size+1;
		
		for (int i=0;i<size;i++)
		{
			for (int j=0;j<size;j++)
			{
				if ((map[i][j].owner	== me) && map[i][j].isConnected)
				{
					int len=abs(i-city[enemy].x)+abs(j-city[enemy].y);
					if (len<min)
					{
						min = len;
						minX = i;
						minY = j;
					}
				}
			}
		}
		int x,y;
		while (legionsCount && (minX!=city[enemy].x || minY!=city[enemy].y) )
		{
			x = city[enemy].x - minX;
			y = city[enemy].y - minY;
			if (x!=0)
			{
				x/=abs(x);
				minX+=x;
			}
			else
			{
				y/=abs(y);
				minY+=y;
			}
			
			MoveTo(minX,minY);
			fprintf(stderr,"%d %d \n",minX,minY);

		}
	
	}

	void Move()
	{
/*
		if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");
		while (legionsCount)
		{
			vector<Point> *ps = GetAccessiblePoints();
			if (ps->size())
			{
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);
			}
			delete ps;
		}
*/
		int x,y;
		
//		if (rand()%100 > 90) 
		Log("System IO eroor");
		bool flag=false;
		
		while (legionsCount && !flag)
		{
			flag=true;
			int diam;
			diam=1;
			for(;diam<size && flag ;diam++){
				for(int i=0;i<=diam*2 && flag ;i++){
					y=city[me].y-diam;
					x=city[me].x-diam+i;
					if(CanMoveToAngry(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
				for(int i=0;i<=diam*2 && flag ;i++){
					y=city[me].y+diam;
					x=city[me].x-diam+i;
					if(CanMoveToAngry(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
				for(int i=0;i<=diam*2 && flag ;i++){
					x=city[me].x-diam;
					y=city[me].y-diam+i;
					if(CanMoveToAngry(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
				for(int i=0;i<=diam*2 && flag ;i++){
					x=city[me].x+diam;
					y=city[me].y-diam+i;
					if(CanMoveToAngry(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
			}
		}
		
		flag=false;
		while (legionsCount && !flag)
		{
			flag=true;
			int diam;
			diam=1;
			for(int diam=1;diam<size && flag ;diam++){
				for(int i=0;i<=diam*2 && flag ;i++){
					y=city[me].y-diam;
					x=city[me].x-diam+i;
					if(CanMoveTo(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
				for(int i=0;i<=diam*2 && flag ;i++){
					y=city[me].y+diam;
					x=city[me].x-diam+i;
					if(CanMoveTo(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
				for(int i=0;i<=diam*2 && flag ;i++){
					x=city[me].x-diam;
					y=city[me].y-diam+i;
					if(CanMoveTo(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
				for(int i=0;i<=diam*2 && flag ;i++){
					x=city[me].x+diam;
					y=city[me].y-diam+i;
					if(CanMoveTo(x, y)){
						MoveTo(x, y);
						diam--;
						flag=false;
					}
				}
			}
		}
		
	}

protected:
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		if (x < 0 || x >= size) return false;
		if (y < 0 || y >= size) return false;

		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool CanMoveToAngry(int x, int y)
	{
		if (x < 0 || x >= size) return false;
		if (y < 0 || y >= size) return false;

		int len=abs(x-city[me].x)+abs(y-city[me].y);
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		if (c.owner == enemy && c.isVeteran && angry < len) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}


	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	void MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "NameLess";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
