/*------------------------------------------------------------
TEAM46
A
178
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <ctime>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}

	void Go(int X, int Y, int dx1, int dy1, int dx2, int dy2, int sz) {
		int x = X, y = Y;

		for(int i = 0; legionsCount && i < sz; ++i) {
			if( CanMoveTo(x, y) )
				MoveTo(x, y);

			x += dx1;
			y += dy1;

		}

		x -= dx1;
		y -= dy1;
		for(int i = 0; legionsCount && i < sz; ++i) {
			if( CanMoveTo(x, y) )
				MoveTo(x, y);

			x += dx2;
			y += dy2;
		}

	}
		
	void Move()
	{
		int X, Y;
		int dx1, dy1;
		int dx2, dy2;

		if( map[0][0].owner == me ) {
			X = Y = 0;
			dx1 = 1; dy1 = 0;
			dx2 = 0; dy2 = 1;
		} else {
			X = Y = size - 1;
			dx1 = 0; dy1 = -1;
			dx2 = -1; dy2 = 0;
		}

		fprintf(stderr, "%d: %d\n", me, legionsCount);

		/* Type 1 */
		Go(X, Y, dx1, dy1, dx2, dy2, 3);

		
		fprintf(stderr, "%d: %d\n", me, legionsCount);

		/* Type 2 */
		Go(X, Y, dy1, dx1, dy2, dx2, size);

		/* Type 3 */
		Go(X, Y, dx1, dy1, dx2, dy2, size);


		/* Samplemizator */
		while (legionsCount) {
			vector<Point> *ps = GetAccessiblePoints();
			if (ps->size())
			{
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);
			}
			delete ps;
		}

	}

protected:
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool Good(int x, int y) {
		if( x < 0 || x >= size )
			return false;
		if( y < 0 || y >= size )
			return false;
		return true;
	}

	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	void MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "Yasha";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
